module WCC
  module Styles
    class Engine < Rails::Railtie
      initializer 'wcc.styles.append_assets_path', group: :all do |app|
        app.config.assets.paths.unshift(*[
          asset_paths("lib/assets"),
          asset_paths("vendor/assets"),
        ].flatten)
        app.config.assets.precompile += [
          %r"^wcc/styles/.+\.(jpg|png|svg)$",
        ]
      end

      initializer 'wcc.styles.simple_form_watermark', group: :all do |app|
        require 'wcc/styles/simple_form' if defined?(SimpleForm)
      end

      initializer 'wcc.styles.add_locales' do |app|
        config.i18n.load_path.concat(Dir[project_path("config/locales/*.yml")])
      end

      private

      def asset_paths(root)
        %w(images javascripts stylesheets).collect do |type|
          project_path(File.join(root, type))
        end
      end

      def project_path(relative_path)
        File.join(WCC::Styles::PROJECT_ROOT, relative_path)
      end
    end
  end
end
