module WCC::Styles::SimpleForm
  class StringArrayInput < SimpleForm::Inputs::Base
    def input(wrapper_options=nil)
      merged_input_options = merge_wrapper_options(input_html_options, wrapper_options)
      field_value = object.public_send(attribute_name)

      template.content_tag(:div, class: "selectize select-style") do
        template.text_field_tag(
          "#{base_input_name}[#{attribute_name}_facade]",
          field_value.join(','),
          "data-string-array-selectize" => "#{base_input_name}[#{attribute_name}]",
        )
      end
    end

    private

    def base_input_name
      @base_input_name ||= "#{lookup_model_names.reduce { |str, item| "#{str}[#{item}]" }}"
    end
  end
end
